#include <cstdlib>
#include <ctime>

#include <iostream>
#include <functional>
#include <list>
#include <queue>
#include <stack>

using namespace std;

struct maxFunctor
{
	bool operator()(const int& a, const int& b) { return a > b; }
};

// Lista rendezse elsbbsgi sorral s veremmel
int main()
{
    srand(time(0));						// Vletlenszm generls inicializlshoz
    
    list<int> l;
    for (int i = 0; i < 10; ++i)
        l.push_back(rand() % 100 + 1);  // Vletlenszmok generlsa 1 s 100 kztt.
		
    cout << "Lista tartalma: " << endl;
    for (list<int>::const_iterator it = l.begin(); it != l.end(); ++it)
        cout << *it << " ";
    cout << endl;
	
    priority_queue<int> prq(l.begin(), l.end());  // Lista tadsa az elsbbsgi sornak
    stack<int> st;

    cout << "Lista csokkenoen rendezve prioritasos sorral: " << endl;
    while(!prq.empty())           // Amg nem res a sor
    {
        cout << prq.top() << " "; // Els elem lekrdezse
        st.push(prq.top());       // Verembe bettel
        prq.pop();                // Els elem trlse
    }
    cout << endl;

    cout << "Lista novekvoen rendezve prioritasos sorral es veremmel: " << endl;
    while(!st.empty())            // Amg nem res a verem
    {
        cout << st.top() << " ";	// Fels elem lekrdezse
        st.pop();                 // Fels elem trlse
    }
    cout << endl;
	
    priority_queue<int, vector<int>, maxFunctor> max_prq(l.begin(), l.end(), maxFunctor());
    //priority_queue<int, vector<int>, maxFunctor> max_prq(l.begin(), l.end());		// Ekvivalens
    //priority_queue<int, vector<int>, greater<int> > max_prq(l.begin(), l.end());	// Ekvivalens
    cout << "Lista novekvoen rendezve prioritasos sorral es funktorral: " << endl;
    
    while(!max_prq.empty())           // Amg nem res a sor
    {
        cout << max_prq.top() << " "; // Els elem lekrdezse
        max_prq.pop();                // Els elem trlse
    }
    cout << endl;
	
    return 0;
}
